/*
 *
 *                Standalone BogoMips program
 *
 * Taken directly from Linux kernel code init/main.c and
 * include/linux/delay.h with minor changes to run outside of kernel.
 *
 * I purposely didn't add any features over what is in the kernel
 * code, because that might have reduced the accuracy :-)
 *
 * For more information on interpreting the results, see the BogoMIPS
 * Mini-HOWTO document (I'm not kidding -- it really exists!)
 *
 */

#include <time.h>
#include <stdio.h>

inline void delay(int loops)
{
  asm(".align 2,0x90\n1:\tdecl %0\n\tjns 1b": :"a" (loops):"ax");
}

int main(void)
{
  unsigned long loops_per_sec = 1;
  int ticks;
  
  printf("Calibrating delay loop.. ");
  while (loops_per_sec <<= 1) {
    ticks = clock();
    delay(loops_per_sec);
    ticks = clock() - ticks;
    if (ticks >= CLOCKS_PER_SEC) {
      asm("mull %1 ; divl %2"
	  :"=a" (loops_per_sec)
	  :"d" (CLOCKS_PER_SEC),
	  "r" (ticks),
	  "0" (loops_per_sec)
	  :"dx");
      printf("ok - %lu.%02lu BogoMips\n",
	     loops_per_sec/500000,
	     (loops_per_sec/5000) % 100);
      return 0;
    }
  }
  printf("failed\n");
  return 0;
}
